#include "parseur.h"

Expression* Parseur::read_int(int first){
  string num;
  while(first >= '0' && first <= '9') {
    num.push_back(first);
    first = texte_exp.get();
  }
  texte_exp.putback(first);
  return new Entier(stoi(num));
}

bool Parseur::estBinOp(int c) {
  return (c == '+') || (c == '-') || (c == '*')
    || (c == '/'); // modif 1
}

Expression* Parseur::construitBinExp(int op, Expression* gauche, Expression* droite) {
  switch(op){
    case '+' : return new Plus(gauche,droite);
    case '-' : return new Moins(gauche,droite);
    case '*' : return new Mult(gauche,droite);
    case '/' : return new Div(gauche,droite); // modif 1
    default: std::cerr << "Opérateur «" << op << "» inconnu." << std::endl;
  }
  exit(1);
}

Expression* Parseur::pop_arg(){
  if(exps_vues.empty()){
    cerr << "Argument manquant." << endl;
    exit(1);
  }
  Expression* val = exps_vues.top();
  exps_vues.pop();
  return val;
}

Expression* Parseur::parse(){
  int c = texte_exp.get();
  while ( c != EOF ){
    if (estBinOp(c)){
      Expression* droite = pop_arg();
      Expression* gauche = pop_arg();
      exps_vues.push(construitBinExp(c,gauche,droite));
    } else if (c >= '0' && c <= '9') {
      exps_vues.push(read_int(c)); 
      // modification 2: construit un objet quand on voit x
    } else if (c == 'x') {
      exps_vues.push(new Variable());
      // fin modification 2
    } else {
      if (c != ' ') {
	cerr << "Caractère «" << (char) c << "» non reconnu." << endl;
	exit(1);
      }
    }
    c = texte_exp.get();
  }
  if (exps_vues.size() > 1) {
    cerr << "Trop d'arguments." << endl;
    exit(1);
  }
  if (exps_vues.empty()) {
    cerr << "Pas d'entrée." << endl;
    exit(1);
  }
  return exps_vues.top();
}
